﻿Imports System.IO
Imports System.Data
Imports System.Reflection
Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Drawing
Imports System.Drawing.Printing
Imports System.Text
Imports System.Windows.Forms
Public Class FLux_Form
    Inherits System.Windows.Forms.Form
    Private WithEvents RssReader As RSS.RssReader
    Private RssFeed As RSS.RssFeed
    Private Const LargeurForm As Integer = 185
    Private Const HauteurForm As Integer = 25
    'objet permettant d'accèder au form principal parent
    Public formPrincipal As Principal
    Private Sub FLux_Form_Load(sender As Object, e As EventArgs) Handles MyBase.Load

        '------------------- Chargement parametres principal
        jj = 0
        FileOpen(1, chemin_para_princ, OpenMode.Input) ' lire 
        While Not EOF(1)
            jj = jj + 1
            data_principal(jj) = LineInput(1).ToString
        End While
        FileClose(1)

        Call choix_couleur()

        Me.Width = 185
        Me.Height = 25

        PictureBox2.Location = New Point(175, 12)
        PictureBox3.Location = New Point(147, 4)
        Panel1.Location = New Point(110, 0)
        'Me.Location = New Point(Position_x, Position_y + 25)
        PictureBox2.Focus()

    End Sub
    Private Sub Flux_Form_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
        rightB.Location = New Point(Me.Size.Width - 2, 0)
        rightB.Size = New Size(2, Me.Size.Height - 5)
    End Sub
    Dim mouse_offset
    Public Property hwnd As Long

    Private Sub FLux_Form_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles MyBase.MouseDown ', PictureBox2.MouseDown
        mouse_offset = New Point(-e.X, -e.Y)
        Me.TopMost = True
    End Sub

    Private Sub FLux_Form_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles MyBase.MouseMove ', PictureBox1.MouseMove

        If e.Button = System.Windows.Forms.MouseButtons.Left Then
            Dim mousePos As Point = Control.MousePosition
            mousePos.Offset(mouse_offset.X, mouse_offset.Y)
            Location = mousePos
            '=============================== BLOCAGES Selon Taille Form PRINCIPAL ================================
            '---------------------------- si Flux_Form < 185
            If Me.Width < 185 Then
                'test X gauche
                If Me.Location.X <= Position_x Then
                    Me.Location = New Point(Position_x, Me.Location.Y)
                    Flux_Windows.Location = New Point(Position_x, Position_y + 49)
                End If
                'Test X Droite
                If Me.Location.X + Me.Width >= Position_x + principal_width Then
                    Me.Location = New Point(principal_width - Me.Width, Me.Location.Y - Position_y - 25)
                    Flux_Windows.Location = New Point(Me.Location.X + Position_x, Position_y + 49)
                    Exit Sub
                End If
                'Test Y haut
                If Me.Location.Y - Position_y - 25 <= 0 Then
                    Me.Location = New Point(Me.Location.X - Position_x, 0)
                    Flux_Windows.Location = New Point(Me.Location.X + Position_x, Position_y + 49)
                    Exit Sub
                End If
                'Test Y bas
                If Me.Location.Y - Position_y - 25 >= ((nbr_form - 1) * 25) Then
                    Me.Location = New Point(Me.Location.X - Position_x, ((nbr_form - 1) * 25))
                    Flux_Windows.Location = New Point(Me.Location.X + Position_x, Me.Location.Y + Position_y + 49)
                    Exit Sub
                End If
                '------- Déplacement Flux_Form dans le form parent
                Me.Location = New Point(Me.Location.X - Position_x, Me.Location.Y - Position_y - 25)
                '-------- Déplacement Flux_Windows avec Flux_Form
                Flux_Windows.Location = New Point(Me.Location.X + Position_x, Me.Location.Y + Position_y + 49)
            End If

            '---------------------------- si Flux_Form = 185
            If Me.Width = 185 Then
                'Test Y haut
                If Me.Location.Y - Position_y - 25 <= 0 Then
                    Me.Location = New Point(0, 0)
                    Flux_Windows.Location = New Point(Position_x, Position_y + 49)
                    Exit Sub
                End If
                'Test Y bas
                If Me.Location.Y - Position_y - 25 >= ((nbr_form - 1) * 25) Then
                    Me.Location = New Point(0, ((nbr_form - 1) * 25))
                    Flux_Windows.Location = New Point(Position_x, Me.Location.Y + Position_y + 49)
                    Exit Sub
                End If
                '-------- Décalage vers Bas et Haut des forms Secondaires
                If Me.Location.Y >= 37 Then
                    Me.Location = New Point(0, 0)
                    ' Positionner à la verticale chaque Form Secondaire par rapport à son précédent
                    Dim i As Integer = 0
                    For Each nvForm As FLux_Form In Principal.listeForms
                        If Not IsNothing(nvForm) Then
                            i = i + 1
                            nvForm.Location = New Point(0, ((i - 1) * 25 + 25))
                        End If
                    Next
                    Exit Sub
                End If
                '------- Déplacement Flux_Form dans le form parent
                Me.Location = New Point(0, Me.Location.Y - Position_y - 25)
                '-------- Déplacement Flux_Windows avec Flux_Form
                Flux_Windows.Location = New Point(Position_x, Me.Location.Y + Position_y + 49)
            End If
            Principal.listeForms(2).Location = New Point(0, 100)
        End If
    End Sub
    Private Sub FLux_Form_Mouseup(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles MyBase.MouseUp ', PictureBox2.MouseUp
        Me.TopMost = False
        If Me.Location.X > Position_x + 185 Then
            Exit Sub
        End If
        If Me.Location.Y > Position_y + 185 Then
            Exit Sub
        End If
    End Sub

    '------------------- Agrandir / Réduite Horizontal Flux-----------------------------------------------------------------
    Private Sub RightB_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles rightB.MouseMove
        If e.Button = System.Windows.Forms.MouseButtons.Left Then
            Me.Size = New Size((MousePosition.X - Position_x), Me.Size.Height)

            If Me.Size.Width > 105 Then
                PictureBox2.Visible = True
                PictureBox3.Visible = True
                Panel1.Visible = True
                Label1.Visible = True
            End If

            If Me.Size.Width <= 105 Then
                PictureBox2.Visible = False
                PictureBox3.Visible = False
                Panel1.Visible = False
            End If

            If Me.Size.Width <= 37 Then
                Me.Width = 37
                PictureBox2.Visible = True
                Label1.Visible = False
                PictureBox2.Location = New Point(24, 12)
                Exit Sub
            End If

            If Me.Size.Width >= 185 Then
                Me.Width = 185
                PictureBox2.Visible = True
                PictureBox2.Location = New Point(185, 12)
                Exit Sub
            End If

            PictureBox2.Location = New Point(Me.Size.Width - 12, 12)
            PictureBox3.Location = New Point(Me.Size.Width - 37, 4)
            Panel1.Location = New Point(Me.Size.Width - 75, 0)
            TextBox1.Width = Me.Width - 134
        End If
    End Sub
    Private Sub RightB_Mouseup(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles rightB.MouseUp
        If Me.Size.Width >= 139 And Me.Size.Width <= 185 Then
            Me.Width = 185
            PictureBox2.Location = New Point(175, 12)
            PictureBox3.Location = New Point(147, 4)
            Panel1.Location = New Point(110, 0)
            TextBox1.Width = Me.Width + 134
        End If
        If Me.Width < 139 And Me.Width >= 46 Then
            Me.Width = 92
            Label1.Visible = True
            PictureBox2.Visible = True
            PictureBox3.Visible = True
            Panel1.Visible = True
            Panel1.Location = New Point(38, 0)
            PictureBox2.Location = New Point(80, 12)
            PictureBox3.Location = New Point(70, 4)
        End If
        If Me.Width < 46 Then
            Me.Width = 37
            PictureBox2.Visible = True
            Label1.Visible = False
            PictureBox2.Location = New Point(24, 12)
            Exit Sub
        End If
    End Sub
    '======================== OUVERTURE / FERMETURE FORM_WINDOWS - Voir les Flux ====================================
    Private Sub TextBox1_Click(sender As Object, e As EventArgs) Handles TextBox1.Click
        Dim total_flux As Integer = 0
        total_flux = Me.Controls.Count - 4
        choix_flux_a_afficher = sender

        Call choix_couleur()

        If flag_ouverture = 1 Then
            PictureBox2.Visible = True
            For Each nvForm As FLux_Form In Principal.listeForms
                If Not IsNothing(nvForm) Then
                    nvForm.PictureBox3.Image = Drawing.Image.FromFile("images\Flux_ouvrir.png")
                End If
            Next
            ToolTip1.SetToolTip(Me.PictureBox3, "Voir les Flux")
            Flux_Windows.Close()
            flag_ouverture = 0
            Exit Sub
        End If
        If flag_ouverture = 0 Then
            PictureBox3.Image = Drawing.Image.FromFile("images\Flux_reduire.png")
            ToolTip1.SetToolTip(Me.PictureBox3, "Fermer les Flux")
            Flux_Form_Taille = Me.Width
            Principal.TopMost = False
            Flux_Windows.TopMost = True
            Flux_Windows.Show()
            Flux_Windows.Location = New Point(Me.Location.X + Position_x, Position_y + Me.Location.Y + 49)
            position_flux_form_x = Me.Location.X
            position_flux_form_y = Me.Location.Y
            flag_ouverture = 1
            Exit Sub
        End If
    End Sub

    Private Sub Label1_Click(sender As Object, e As EventArgs) Handles Label1.Click
        Dim total_flux As Integer = 0
        total_flux = Me.Controls.Count - 4
        choix_flux_a_afficher = sender

        Call choix_couleur()

        If flag_ouverture = 1 Then
            PictureBox2.Visible = True
            For Each nvForm As FLux_Form In Principal.listeForms
                If Not IsNothing(nvForm) Then
                    nvForm.PictureBox3.Image = Drawing.Image.FromFile("images\Flux_ouvrir.png")
                End If
            Next
            ToolTip1.SetToolTip(Me.PictureBox3, "Voir les Flux")
            Flux_Windows.Close()
            flag_ouverture = 0
            Exit Sub
        End If
        If flag_ouverture = 0 Then
            PictureBox3.Image = Drawing.Image.FromFile("images\Flux_reduire.png")
            ToolTip1.SetToolTip(Me.PictureBox3, "Fermer les Flux")
            Flux_Form_Taille = Me.Width
            Principal.TopMost = False
            Flux_Windows.TopMost = True
            Flux_Windows.Show()
            Flux_Windows.Location = New Point(Me.Location.X + Position_x, Position_y + Me.Location.Y + 49)
            position_flux_form_x = Me.Location.X
            position_flux_form_y = Me.Location.Y
            flag_ouverture = 1
            Exit Sub
        End If
    End Sub

    Private Sub PictureBox3_Click(sender As Object, e As EventArgs) Handles PictureBox3.Click
        Dim total_flux As Integer = 0
        total_flux = Me.Controls.Count - 4
        choix_flux_a_afficher = sender

        Call choix_couleur()

        If flag_ouverture = 1 Then
            PictureBox2.Visible = True
            For Each nvForm As FLux_Form In Principal.listeForms
                If Not IsNothing(nvForm) Then
                    nvForm.PictureBox3.Image = Drawing.Image.FromFile("images\Flux_ouvrir.png")
                End If
            Next
            ToolTip1.SetToolTip(Me.PictureBox3, "Voir les Flux")
            Flux_Windows.Close()
            flag_ouverture = 0
            Exit Sub
        End If
        If flag_ouverture = 0 Then
            PictureBox3.Image = Drawing.Image.FromFile("images\Flux_reduire.png")
            ToolTip1.SetToolTip(Me.PictureBox3, "Fermer les Flux")
            Flux_Form_Taille = Me.Width
            Principal.TopMost = False
            Flux_Windows.TopMost = True
            Flux_Windows.Show()
            Flux_Windows.Location = New Point(Me.Location.X + Position_x, Position_y + Me.Location.Y + 49)
            position_flux_form_x = Me.Location.X
            position_flux_form_y = Me.Location.Y
            flag_ouverture = 1
            Exit Sub
        End If
    End Sub

    Private Sub PictureBox1_Click(sender As Object, e As EventArgs) Handles PictureBox1.Click
        Dim total_flux As Integer = 0
        total_flux = Me.Controls.Count - 4
        choix_flux_a_afficher = sender

        Call choix_couleur()

        If flag_ouverture = 1 Then
                PictureBox2.Visible = True
            For Each nvForm As FLux_Form In Principal.listeForms
                If Not IsNothing(nvForm) Then
                    nvForm.PictureBox3.Image = Drawing.Image.FromFile("images\Flux_ouvrir.png")
                End If
            Next
            ToolTip1.SetToolTip(Me.PictureBox3, "Voir les Flux")
            Flux_Windows.Close()
                flag_ouverture = 0
                Exit Sub
            End If
        If flag_ouverture = 0 Then
            PictureBox3.Image = Drawing.Image.FromFile("images\Flux_reduire.png")
            ToolTip1.SetToolTip(Me.PictureBox3, "Fermer les Flux")
            Flux_Form_Taille = Me.Width
            Principal.TopMost = False
            Flux_Windows.TopMost = True
            Flux_Windows.Show()
            Flux_Windows.Location = New Point(Me.Location.X + Position_x, Position_y + Me.Location.Y + 49)

            position_flux_form_x = Me.Location.X
            position_flux_form_y = Me.Location.Y
            flag_ouverture = 1
            Exit Sub
        End If
    End Sub
    Private Sub MenuStrip1_ItemClicked(sender As Object, e As ToolStripItemClickedEventArgs) Handles MenuStrip1.ItemClicked

    End Sub

    Private Sub AjoutRSSToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles AjoutRSSToolStripMenuItem.Click
        Flux_Ajout.Show()
    End Sub

    Private Sub PictureBox2_Click(sender As Object, e As EventArgs) Handles PictureBox2.Click

    End Sub
    Sub choix_couleur()
        jj = 0
        '------------------- Chargement parametres principal
        FileOpen(1, chemin_para_princ, OpenMode.Input) ' lire 
        While Not EOF(1)
            jj = jj + 1
            data_principal(jj) = LineInput(1).ToString
        End While
        FileClose(1)

        'Couleurs Form
        If data_principal(1) = "1" Then
            Me.BackColor = Color.Black
            Me.AjoutRSSToolStripMenuItem.BackColor = Color.Gray
            Me.ActualiserToolStripMenuItem.BackColor = Color.Gray
            Me.IconesToolStripMenuItem.BackColor = Color.Gray
            Me.TextBox1.BackColor = Color.Black
            Flux_Windows.BackColor = Color.Black
            Flux_Windows.lstItems.BackColor = Color.Black
            Flux_Windows.MenuStrip1.BackColor = Color.Black
            Flux_Windows.AjoutRSSToolStripMenuItem.BackColor = Color.Gray
            Flux_Windows.ActualiserToolStripMenuItem.BackColor = Color.Gray
            Flux_Windows.IconesToolStripMenuItem.BackColor = Color.Gray
            Flux_Windows.PictureBox3.BackColor = Color.Black
            Flux_Ajout.BackColor = Color.Black
            Flux_Ajout.Label1.BackColor = Color.Black
            Flux_Ajout.Label2.BackColor = Color.Black
            Flux_Ajout.new_flux_ajout.BackColor = Color.Black
        End If
        If data_principal(1) = "2" Then
            Me.BackColor = Color.Maroon
            Me.AjoutRSSToolStripMenuItem.BackColor = Color.LightCoral
            Me.ActualiserToolStripMenuItem.BackColor = Color.LightCoral
            Me.IconesToolStripMenuItem.BackColor = Color.LightCoral
            Me.TextBox1.BackColor = Color.Maroon
            Flux_Windows.BackColor = Color.Maroon
            Flux_Windows.lstItems.BackColor = Color.Maroon
            Flux_Windows.MenuStrip1.BackColor = Color.Maroon
            Flux_Windows.AjoutRSSToolStripMenuItem.BackColor = Color.LightCoral
            Flux_Windows.ActualiserToolStripMenuItem.BackColor = Color.LightCoral
            Flux_Windows.IconesToolStripMenuItem.BackColor = Color.LightCoral
            Flux_Windows.PictureBox3.BackColor = Color.Maroon
            Flux_Ajout.BackColor = Color.Maroon
            Flux_Ajout.Label1.BackColor = Color.Maroon
            Flux_Ajout.Label2.BackColor = Color.Maroon
            Flux_Ajout.new_flux_ajout.BackColor = Color.Maroon
        End If
        If data_principal(1) = "3" Then
            Me.BackColor = Color.Chocolate
            Me.AjoutRSSToolStripMenuItem.BackColor = Color.SandyBrown
            Me.ActualiserToolStripMenuItem.BackColor = Color.SandyBrown
            Me.IconesToolStripMenuItem.BackColor = Color.SandyBrown
            Me.TextBox1.BackColor = Color.Chocolate
            Flux_Windows.BackColor = Color.Chocolate
            Flux_Windows.lstItems.BackColor = Color.Chocolate
            Flux_Windows.MenuStrip1.BackColor = Color.Chocolate
            Flux_Windows.AjoutRSSToolStripMenuItem.BackColor = Color.SandyBrown
            Flux_Windows.ActualiserToolStripMenuItem.BackColor = Color.SandyBrown
            Flux_Windows.IconesToolStripMenuItem.BackColor = Color.SandyBrown
            Flux_Windows.PictureBox3.BackColor = Color.Chocolate
            Flux_Ajout.BackColor = Color.Chocolate
            Flux_Ajout.Label1.BackColor = Color.Chocolate
            Flux_Ajout.Label2.BackColor = Color.Chocolate
            Flux_Ajout.new_flux_ajout.BackColor = Color.Chocolate
        End If
        If data_principal(1) = "4" Then
            Me.BackColor = Color.Green
            Me.AjoutRSSToolStripMenuItem.BackColor = Color.LimeGreen
            Me.ActualiserToolStripMenuItem.BackColor = Color.LimeGreen
            Me.IconesToolStripMenuItem.BackColor = Color.LimeGreen
            Me.TextBox1.BackColor = Color.Green
            Flux_Windows.BackColor = Color.Green
            Flux_Windows.lstItems.BackColor = Color.Green
            Flux_Windows.MenuStrip1.BackColor = Color.Green
            Flux_Windows.AjoutRSSToolStripMenuItem.BackColor = Color.LimeGreen
            Flux_Windows.ActualiserToolStripMenuItem.BackColor = Color.LimeGreen
            Flux_Windows.IconesToolStripMenuItem.BackColor = Color.LimeGreen
            Flux_Windows.PictureBox3.BackColor = Color.Green
            Flux_Ajout.BackColor = Color.Green
            Flux_Ajout.Label1.BackColor = Color.Green
            Flux_Ajout.Label2.BackColor = Color.Green
            Flux_Ajout.new_flux_ajout.BackColor = Color.Green
        End If
        If data_principal(1) = "5" Then
            Me.BackColor = Color.Teal
            Me.AjoutRSSToolStripMenuItem.BackColor = Color.LightSeaGreen
            Me.ActualiserToolStripMenuItem.BackColor = Color.LightSeaGreen
            Me.IconesToolStripMenuItem.BackColor = Color.LightSeaGreen
            Me.TextBox1.BackColor = Color.Teal
            Flux_Windows.BackColor = Color.Teal
            Flux_Windows.lstItems.BackColor = Color.Teal
            Flux_Windows.MenuStrip1.BackColor = Color.Teal
            Flux_Windows.AjoutRSSToolStripMenuItem.BackColor = Color.LightSeaGreen
            Flux_Windows.ActualiserToolStripMenuItem.BackColor = Color.LightSeaGreen
            Flux_Windows.IconesToolStripMenuItem.BackColor = Color.LightSeaGreen
            Flux_Windows.PictureBox3.BackColor = Color.Teal
            Flux_Ajout.BackColor = Color.Teal
            Flux_Ajout.Label1.BackColor = Color.Teal
            Flux_Ajout.Label2.BackColor = Color.Teal
            Flux_Ajout.new_flux_ajout.BackColor = Color.Teal
        End If
        If data_principal(1) = "6" Then
            Me.BackColor = Color.Navy
            Me.AjoutRSSToolStripMenuItem.BackColor = Color.RoyalBlue
            Me.ActualiserToolStripMenuItem.BackColor = Color.RoyalBlue
            Me.IconesToolStripMenuItem.BackColor = Color.RoyalBlue
            Me.TextBox1.BackColor = Color.Navy
            Flux_Windows.BackColor = Color.Navy
            Flux_Windows.lstItems.BackColor = Color.Navy
            Flux_Windows.MenuStrip1.BackColor = Color.Navy
            Flux_Windows.AjoutRSSToolStripMenuItem.BackColor = Color.RoyalBlue
            Flux_Windows.ActualiserToolStripMenuItem.BackColor = Color.RoyalBlue
            Flux_Windows.IconesToolStripMenuItem.BackColor = Color.RoyalBlue
            Flux_Windows.PictureBox3.BackColor = Color.Navy
            Flux_Ajout.BackColor = Color.Navy
            Flux_Ajout.Label1.BackColor = Color.Navy
            Flux_Ajout.Label2.BackColor = Color.Navy
            Flux_Ajout.new_flux_ajout.BackColor = Color.Navy
        End If
        If data_principal(1) = "7" Then
            Me.BackColor = Color.Indigo
            Me.AjoutRSSToolStripMenuItem.BackColor = Color.MediumPurple
            Me.ActualiserToolStripMenuItem.BackColor = Color.MediumPurple
            Me.IconesToolStripMenuItem.BackColor = Color.MediumPurple
            Me.TextBox1.BackColor = Color.Indigo
            Flux_Windows.BackColor = Color.Indigo
            Flux_Windows.lstItems.BackColor = Color.Indigo
            Flux_Windows.MenuStrip1.BackColor = Color.Indigo
            Flux_Windows.AjoutRSSToolStripMenuItem.BackColor = Color.MediumPurple
            Flux_Windows.ActualiserToolStripMenuItem.BackColor = Color.MediumPurple
            Flux_Windows.IconesToolStripMenuItem.BackColor = Color.MediumPurple
            Flux_Windows.PictureBox3.BackColor = Color.Indigo
            Flux_Ajout.BackColor = Color.Indigo
            Flux_Ajout.Label1.BackColor = Color.Indigo
            Flux_Ajout.Label2.BackColor = Color.Indigo
            Flux_Ajout.new_flux_ajout.BackColor = Color.Indigo
        End If
        If data_principal(1) = "8" Then
            Me.BackColor = Color.Purple
            Me.AjoutRSSToolStripMenuItem.BackColor = Color.Violet
            Me.ActualiserToolStripMenuItem.BackColor = Color.Violet
            Me.IconesToolStripMenuItem.BackColor = Color.Violet
            Me.TextBox1.BackColor = Color.Purple
            Flux_Windows.BackColor = Color.Purple
            Flux_Windows.lstItems.BackColor = Color.Purple
            Flux_Windows.MenuStrip1.BackColor = Color.Purple
            Flux_Windows.AjoutRSSToolStripMenuItem.BackColor = Color.Violet
            Flux_Windows.ActualiserToolStripMenuItem.BackColor = Color.Violet
            Flux_Windows.IconesToolStripMenuItem.BackColor = Color.Violet
            Flux_Windows.PictureBox3.BackColor = Color.Purple
            Flux_Ajout.BackColor = Color.Purple
            Flux_Ajout.Label1.BackColor = Color.Purple
            Flux_Ajout.Label2.BackColor = Color.Purple
            Flux_Ajout.new_flux_ajout.BackColor = Color.Purple
        End If
    End Sub
End Class