﻿Imports System.IO
Imports System.Data
Imports System.Reflection
Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Drawing
Imports System.Drawing.Printing
Imports System.Text
Imports System.Windows.Forms
Public Class Flux_Windows
    Inherits System.Windows.Forms.Form
    Private WithEvents RssReader As RSS.RssReader
    Private RssFeed As RSS.RssFeed

    Private Sub Flux_Windows_Load(sender As Object, e As EventArgs)
        ToolTip1.SetToolTip(Me.rightB, "Agrandir/Réduire Horizontalement")
        ToolTip1.SetToolTip(Me.DownB, "Agrandir/Réduire Verticalement")
        ToolTip1.SetToolTip(Me.ObliqueB, "Diminuer la Fenêtre")

    End Sub
    Private Sub RightB_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles rightB.MouseMove
        If e.Button = System.Windows.Forms.MouseButtons.Left Then

            Me.Size = New Size(MousePosition.X - Me.Location.X, Me.Size.Height)
            lstItems.Size = New Size(MousePosition.X - Me.Location.X - 25, Me.Size.Height - 22)
            Panel1.Location = New Point(MousePosition.X - Me.Location.X - 56, 1)
            PictureBox3.Location = New Point(MousePosition.X - Me.Location.X - 23, 5)
            ObliqueB.Location = New Point(MousePosition.X - Me.Location.X - 11, Me.Size.Height - 11)

            If Me.Size.Width <= 185 Then
                Me.Width = 185
                lstItems.Width = 160
                Panel1.Location = New Point(124, 1)
                PictureBox3.Location = New Point(160, 5)
                ObliqueB.Location = New Point(175, Me.Size.Height - 11)
            End If
        End If
        flux_windows_height = Me.Height
        flux_windows_width = Me.Width
    End Sub
    Private Sub DownB_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles DownB.MouseMove
        If e.Button = System.Windows.Forms.MouseButtons.Left Then
            Me.Size = New Size(Me.Size.Width, MousePosition.Y - Me.Location.Y)
            lstItems.Size = New Size(Me.Size.Width - 25, MousePosition.Y - Me.Location.Y - 22)
            ObliqueB.Location = New Point(Me.Size.Width - 11, MousePosition.Y - Me.Location.Y - 11)
            If Me.Size.Height <= 45 Then
                Me.Height = 45
                ObliqueB.Location = New Point(Me.Size.Width - 11, Me.Size.Height - 11)
            End If
        End If
        flux_windows_height = Me.Height
        flux_windows_width = Me.Width
    End Sub
    Private Sub ObliqueB_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles ObliqueB.MouseMove
        If e.Button = System.Windows.Forms.MouseButtons.Left Then
            Me.Size = New Size(MousePosition.X - Me.Location.X, MousePosition.Y - Me.Location.Y)
            lstItems.Size = New Size(MousePosition.X - Me.Location.X - 25, MousePosition.Y - Me.Location.Y - 22)
            Panel1.Location = New Point(MousePosition.X - Me.Location.X - 56, 1)
            PictureBox3.Location = New Point(MousePosition.X - Me.Location.X - 23, 5)
            ObliqueB.Location = New Point(MousePosition.X - Me.Location.X - 11, MousePosition.Y - Me.Location.Y - 11)
            If Me.Size.Width <= 185 Then
                Me.Width = 185
                lstItems.Width = 160
                ObliqueB.Location = New Point(175, Me.Size.Height - 11)
            End If
            If Me.Size.Height <= 45 Then
                Me.Height = 45
                ObliqueB.Location = New Point(Me.Size.Width - 11, Me.Size.Height - 11)
            End If
        End If
        flux_windows_height = Me.Height
        flux_windows_width = Me.Width
    End Sub
    Private Sub Form1_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
        DownB.Location = New Point(0, Me.Size.Height - 2)
        rightB.Location = New Point(Me.Size.Width - 2, 0)
        DownB.Size = New Size(Me.Size.Width, 2)
        rightB.Size = New Size(2, Me.Size.Height)
        flux_windows_height = Me.Height
        flux_windows_width = Me.Width
    End Sub
    Private Sub FluxWindowsMouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Me.MouseMove
        Me.Show()
    End Sub
    Private Sub meeLeave(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Me.MouseLeave

    End Sub
    '=================================== lecture FLUX ============================================================================
    Private Sub Flux_Windows_Load_1(sender As Object, e As EventArgs) Handles MyBase.Load
        flux_windows_height = Me.Height
        flux_windows_width = Me.Width
        position_flux_form_x = Me.Location.X
        position_flux_form_y = Me.Location.Y

        If Flux_Form_Taille <= 37 Then
            PictureBox3.Image = Drawing.Image.FromFile("images\Flux_reduire.png")
            PictureBox3.Visible = True
            Panel1.Visible = True
        Else
            PictureBox3.Visible = False
            Panel1.Visible = False
        End If


        'lblTitle.Text = ""
        'lblDescription.Text = ""
        'picImage.Image = Nothing
        'lstRssItems.Items.Clear()

        ' Téléchargement du flux
        RssReader = New RSS.RssReader
        'RssReader.Load(New Uri(txtURL.Text))
    End Sub
    Private Sub Reader_Completed(ByVal Sender As Object, ByVal e As RSS.RssReader.CompletedEventArgs) Handles RssReader.Completed
        RssFeed = e.Result
        'RssFeed.LoadImage()

        ' Affichage des résultats
        ShowDetailed()
        ShowJoli()
    End Sub

#Region " Detailed "

    Private Sub ShowDetailed()
        'Me.lstChannelElements.Items.Clear()
        Me.lstItems.Items.Clear()
        For Each Tag As RSS.RssTag In RssFeed.Elements
            'Me.lstChannelElements.Items.Add(Tag.Name & " = " & Tag.Value)
        Next
        For Each item As RSS.RssItem In RssFeed.Items
            Me.lstItems.Items.Add(item.title)
        Next
    End Sub


    Private Sub lstItems_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lstItems.SelectedIndexChanged
        If lstItems.SelectedIndex >= 0 Then
            'lstItemElements.Items.Clear()
            For Each Tag As RSS.RssTag In RssFeed.Items(lstItems.SelectedIndex).Elements
                'Me.lstItemElements.Items.Add(Tag.Name & " = " & Tag.Value)
            Next
        End If
    End Sub

#End Region

#Region " Joli "

    Private Sub ShowJoli()
        'lblTitle.Text = RssFeed.title
        'lblDescription.Text = RssFeed.description
        'picImage.Visible = False
        'picImage.LoadAsync(RssFeed.imageUrl)

        For Each item As RSS.RssItem In RssFeed.Items
            'lstRssItems.Items.Add(item)
        Next
    End Sub

    'Private Sub picImage_LoadCompleted(ByVal sender As Object, ByVal e As System.ComponentModel.AsyncCompletedEventArgs) Handles picImage.LoadCompleted
    'picImage.Visible = True
    'End Sub

    'Private Sub lstRssItems_MeasureItem(ByVal sender As Object, ByVal e As System.Windows.Forms.MeasureItemEventArgs) Handles lstRssItems.MeasureItem
    'e.ItemWidth = lstRssItems.Width
    'Dim rssItem As RSS.RssItem = RssFeed.Items(e.Index)
    'Dim DescrHeight As Integer = e.Graphics.MeasureString(rssItem.description, DescrFont, e.ItemWidth - 20).Height
    'e.ItemHeight = 20 + DescrHeight
    'End Sub
    'Private Sub lstRssItems_DrawItem(ByVal sender As Object, ByVal e As System.Windows.Forms.DrawItemEventArgs) Handles lstRssItems.DrawItem
    'Dim item As RSS.RssItem = RssFeed.Items(e.Index)
    ' Titre
    'Dim titleRect As New Rectangle(0, e.Bounds.Top, e.Bounds.Width, 20)
    'Dim TitleBrush As New Drawing2D.LinearGradientBrush(titleRect, Color.LightBlue, Color.Blue, Drawing2D.LinearGradientMode.Vertical)
    'e.Graphics.FillRectangle(TitleBrush, titleRect)
    'e.Graphics.DrawString(item.title, TitleFont, Brushes.White, titleRect)

    'Dim DescrRect As New Rectangle(10, e.Bounds.Top + 20, e.Bounds.Width - 20, e.Bounds.Height - 20)
    'e.Graphics.DrawString(item.description, DescrFont, Brushes.Black, DescrRect)
    'End Sub
    Private TitleFont As New Font("Verdana", 10, FontStyle.Bold)
    Private DescrFont As New Font("Verdana", 10, FontStyle.Regular)

    Private Sub AjoutRSSToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles AjoutRSSToolStripMenuItem.Click
        Flux_Ajout.Show()
    End Sub

    Private Sub PictureBox3_Click(sender As Object, e As EventArgs) Handles PictureBox3.Click
        For Each nvForm As FLux_Form In Principal.listeForms
            If Not IsNothing(nvForm) Then
                nvForm.PictureBox3.Image = Drawing.Image.FromFile("images\Flux_ouvrir.png")
            End If
        Next

        Me.Close()
    End Sub
#End Region
End Class