﻿Imports System.IO
Imports System.Data
Imports System.Reflection
Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Drawing
Imports System.Drawing.Printing
Imports System.Text
Imports System.Windows.Forms
Imports System.Windows
Public Class Principal
    Inherits System.Windows.Forms.Form
    Private WithEvents RssReader As RSS.RssReader
    Private RssFeed As RSS.RssFeed
    Private Const LargeurForm As Integer = 185
    Private Const HauteurForm As Integer = 25
    Public Property Client As MdiClient
    'liste dynamique contenant les formulaires secondaires pour les traiter par lot
    Public listeForms() As FLux_Form
    Public nvform As Form

    Private Sub Principal_Load(sender As Object, e As EventArgs) Handles MyBase.Load

        Me.Width = 185
        Me.Height = 625
        principal_width = Me.Width
        principal_height = Me.Height

        PictureBox1.Location = New Point(174, 11)

        j = 0
        '------------------- Chargement parametres principal
        FileOpen(1, chemin_para_princ, OpenMode.Input) ' lire 
        While Not EOF(1)
            j = j + 1
            data_principal(j) = LineInput(1).ToString
        End While
        FileClose(1)
        cpt_para_principal = j + 1
        Principal_x = data_principal(2)
        principal_y = data_principal(3)
        Me.Location = New Point(Val(Principal_x), Val(principal_y))

        Call choix_couleur()

        '---------------------Chargement des Flux
        j = -1 : cpt_flux = 0
        FileOpen(1, nom_fichier, OpenMode.Input) ' lire 
        While Not EOF(1)
            j = j + 1
            data(j) = LineInput(1).ToString
        End While
        FileClose(1)
        cpt_flux = j + 1


        If cpt_flux = -1 Then
            Exit Sub
        Else
            Me.Width = 185
            Me.Height = 625
            ReDim listeForms(1)

            Me.TransparencyKey = Color.FromArgb(255, 220, 33, 55)
            Dim Client = New MdiClient()
            Me.Controls.Add(Client)

            j = 0
            For j = 0 To cpt_flux - 1
                Dim nvform = New FLux_Form()
                nvform.PictureBox1.Width = 20
                nvform.PictureBox1.Height = 20
                nvform.PictureBox1.Image = Drawing.Image.FromFile("images\rss_20.png")
                nvform.PictureBox1.Left = 3
                nvform.PictureBox1.Top = 2
                nvform.TextBox1.Text = "Flux" & Str(j + 1)
                Position_x = Me.Location.X
                Position_y = Me.Location.Y
                'stocker le Form secondaire dans listeForms
                Dim nbFluxForms = UBound(listeForms)
                Dim i As Integer = nbFluxForms + 1
                ReDim Preserve listeForms(i)
                listeForms(i) = nvform
                nvform.MdiParent = Me
                Me.PictureBox3.Controls.Add(nvform)
                nvform.Show()
            Next
        End If
        'repositionner tous les form secondaires 
        Positioner_FluxForm()
        'Nombre de Form Secondaire (Flux_Form) de crées
        nbr_form = UBound(Me.listeForms) - 1

    End Sub
    Public Sub Positioner_FluxForm()
        ' Positionner à la verticale chaque Form Secondaire par rapport à son précédent
        Dim i As Integer = 0
        For Each nvForm As FLux_Form In Me.listeForms
            If Not IsNothing(nvForm) Then
                i = i + 1
                nvForm.Location = New Point(0, ((i - 1) * nvForm.Height))
            End If
        Next
    End Sub

    Dim mouse_offset
    Private Sub Principal_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles MenuStrip1.MouseDown, PictureBox1.MouseDown
        mouse_offset = New Point(-e.X, -e.Y)
    End Sub
    Private Sub Principal_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles MenuStrip1.MouseMove, PictureBox1.MouseMove
        If e.Button = System.Windows.Forms.MouseButtons.Left Then
            Dim mousePos As Point = Control.MousePosition
            mousePos.Offset(mouse_offset.X, mouse_offset.Y)
            Location = mousePos
            Position_x = Me.Location.X
            Position_y = Me.Location.Y

            Dim LargeurEcran As Integer = Screen.PrimaryScreen.WorkingArea.Width
            Dim HauteurEcran As Integer = Screen.PrimaryScreen.WorkingArea.Height

            '------------------------------- BLOCAGES Selon Taille ECRAN --------------------------------------------
            'Test X Droite
            If Me.Location.X + LargeurForm > LargeurEcran Then
                Me.Location = New Point(LargeurEcran - LargeurForm, Me.Location.Y)
                Exit Sub
            End If
            'Test X Gauche
            If Me.Location.X < 0 Then
                Me.Location = New Point(0, Me.Location.Y)
                Exit Sub
            End If
            'Test Y Haut
            If Me.Location.Y < 0 Then
                Me.Location = New Point(Me.Location.X, 0)
                Exit Sub
            End If
            'Test Y Bas
            '----- Test selon barre de tâche cachée ou pas 
            If Me.Location.Y + HauteurForm + 25 > (HauteurEcran - (25 * (nbr_form - 1))) And Me.ShowInTaskbar = False Then
                Me.Location = New Point(Me.Location.X, HauteurEcran - (25 * (nbr_form + 1)))
                Exit Sub
            End If
            If Me.Location.Y + HauteurForm > (HauteurEcran + (25 * (nbr_form - 1))) And Me.ShowInTaskbar = True Then
                Me.Location = New Point(Me.Location.X, HauteurEcran - HauteurForm)
                Exit Sub
            End If
            Me.Location = New Point(Me.Location.X, Me.Location.Y)
            Flux_Windows.Location = New Point(Me.Location.X + position_flux_form_x,
                                              Me.Location.Y + 25 + position_flux_form_y + 24)
        End If
    End Sub

    Private Sub AjoutDeFluxToolStripMenuItem_Click(sender As Object, e As EventArgs)
        Flux_Ajout.Show()
    End Sub
    Private Sub QuitterToolStripMenuItem_Click(sender As Object, e As EventArgs)
        Me.Close()
    End Sub
    Private Sub AjoutToolStripMenuItem1_Click(sender As Object, e As EventArgs)
        Flux_Ajout.Show()
    End Sub

    Private Sub QuitterToolStripMenuItem1_Click(sender As Object, e As EventArgs)
        Me.Close()
    End Sub

    Private Sub PictureBox2_Click(sender As Object, e As EventArgs)
        'A Propos
    End Sub
    '------------------------------------------------- COULEURS -------------------------------------------------------
    Public Sub choix_couleur()
        'Couleurs Form
        If data_principal(1) = "1" Then 'Couleur Gris Foncé
            Me.BackColor = Color.Black
            Me.MenuStrip1.BackColor = Color.Black
            Me.PictureBox1.BackColor = Color.Black
            Me.PictureBox2.BackColor = Color.Black
            Me.AjoutDeFluxToolStripMenuItem.BackColor = Color.Gray
            Me.ParamétresToolStripMenuItem1.BackColor = Color.Gray
            Me.AProposToolStripMenuItem.BackColor = Color.Gray
            Me.AideToolStripMenuItem.BackColor = Color.Gray
            Me.QuitterToolStripMenuItem.BackColor = Color.Gray
            FLux_Form.BackColor = Color.Black
            FLux_Form.TextBox1.BackColor = Color.Black
            Flux_Windows.BackColor = Color.Black
            Flux_Windows.lstItems.BackColor = Color.Black
            Flux_Windows.MenuStrip1.BackColor = Color.Black
            Flux_Windows.AjoutRSSToolStripMenuItem.BackColor = Color.Gray
            Flux_Windows.ActualiserToolStripMenuItem.BackColor = Color.Gray
            Flux_Windows.IconesToolStripMenuItem.BackColor = Color.Gray
            Flux_Windows.PictureBox3.BackColor = Color.Black
            Flux_Ajout.BackColor = Color.Black
            Flux_Ajout.Label1.BackColor = Color.Black
            Flux_Ajout.Label2.BackColor = Color.Black
            Flux_Ajout.new_flux_ajout.BackColor = Color.Black

        End If
        If data_principal(1) = "2" Then 'Couleur Rouge Sombre
            Me.BackColor = Color.Maroon
            Me.MenuStrip1.BackColor = Color.Maroon
            Me.PictureBox1.BackColor = Color.Maroon
            Me.PictureBox2.BackColor = Color.Maroon
            Me.AjoutDeFluxToolStripMenuItem.BackColor = Color.LightCoral
            Me.ParamétresToolStripMenuItem1.BackColor = Color.LightCoral
            Me.AProposToolStripMenuItem.BackColor = Color.LightCoral
            Me.AideToolStripMenuItem.BackColor = Color.LightCoral
            Me.QuitterToolStripMenuItem.BackColor = Color.LightCoral
            FLux_Form.BackColor = Color.Maroon
            FLux_Form.TextBox1.BackColor = Color.Maroon
            Flux_Windows.BackColor = Color.Maroon
            Flux_Windows.lstItems.BackColor = Color.Maroon
            Flux_Windows.MenuStrip1.BackColor = Color.Maroon
            Flux_Windows.AjoutRSSToolStripMenuItem.BackColor = Color.LightCoral
            Flux_Windows.ActualiserToolStripMenuItem.BackColor = Color.LightCoral
            Flux_Windows.IconesToolStripMenuItem.BackColor = Color.LightCoral
            Flux_Windows.PictureBox3.BackColor = Color.Maroon
            Flux_Ajout.BackColor = Color.Maroon
            Flux_Ajout.Label1.BackColor = Color.Maroon
            Flux_Ajout.Label2.BackColor = Color.Maroon
            Flux_Ajout.new_flux_ajout.BackColor = Color.Maroon
        End If
        If data_principal(1) = "3" Then 'Couleur Marron
            Me.BackColor = Color.Chocolate
            Me.MenuStrip1.BackColor = Color.Chocolate
            Me.PictureBox1.BackColor = Color.Chocolate
            Me.PictureBox2.BackColor = Color.Chocolate
            Me.AjoutDeFluxToolStripMenuItem.BackColor = Color.SandyBrown
            Me.ParamétresToolStripMenuItem1.BackColor = Color.SandyBrown
            Me.AProposToolStripMenuItem.BackColor = Color.SandyBrown
            Me.AideToolStripMenuItem.BackColor = Color.SandyBrown
            Me.QuitterToolStripMenuItem.BackColor = Color.SandyBrown
            FLux_Form.BackColor = Color.Chocolate
            FLux_Form.TextBox1.BackColor = Color.Chocolate
            Flux_Windows.BackColor = Color.Chocolate
            Flux_Windows.lstItems.BackColor = Color.Chocolate
            Flux_Windows.MenuStrip1.BackColor = Color.Chocolate
            Flux_Windows.AjoutRSSToolStripMenuItem.BackColor = Color.SandyBrown
            Flux_Windows.ActualiserToolStripMenuItem.BackColor = Color.SandyBrown
            Flux_Windows.IconesToolStripMenuItem.BackColor = Color.SandyBrown
            Flux_Windows.PictureBox3.BackColor = Color.Chocolate
            Flux_Ajout.BackColor = Color.Chocolate
            Flux_Ajout.Label1.BackColor = Color.Chocolate
            Flux_Ajout.Label2.BackColor = Color.Chocolate
            Flux_Ajout.new_flux_ajout.BackColor = Color.Chocolate
        End If
        If data_principal(1) = "4" Then 'Couleur Vert sombre
            Me.BackColor = Color.Green
            Me.MenuStrip1.BackColor = Color.Green
            Me.PictureBox1.BackColor = Color.Green
            Me.PictureBox2.BackColor = Color.Green
            Me.AjoutDeFluxToolStripMenuItem.BackColor = Color.LimeGreen
            Me.ParamétresToolStripMenuItem1.BackColor = Color.LimeGreen
            Me.AProposToolStripMenuItem.BackColor = Color.LimeGreen
            Me.AideToolStripMenuItem.BackColor = Color.LimeGreen
            Me.QuitterToolStripMenuItem.BackColor = Color.LimeGreen
            FLux_Form.BackColor = Color.Green
            FLux_Form.TextBox1.BackColor = Color.Green
            Flux_Windows.BackColor = Color.Green
            Flux_Windows.lstItems.BackColor = Color.Green
            Flux_Windows.MenuStrip1.BackColor = Color.Green
            Flux_Windows.AjoutRSSToolStripMenuItem.BackColor = Color.LimeGreen
            Flux_Windows.ActualiserToolStripMenuItem.BackColor = Color.LimeGreen
            Flux_Windows.IconesToolStripMenuItem.BackColor = Color.LimeGreen
            Flux_Windows.PictureBox3.BackColor = Color.Green
            Flux_Ajout.BackColor = Color.Green
            Flux_Ajout.Label1.BackColor = Color.Green
            Flux_Ajout.Label2.BackColor = Color.Green
            Flux_Ajout.new_flux_ajout.BackColor = Color.Green
        End If
        If data_principal(1) = "5" Then 'Couleur Vert bleu
            Me.BackColor = Color.Teal
            Me.MenuStrip1.BackColor = Color.Teal
            Me.PictureBox1.BackColor = Color.Teal
            Me.PictureBox2.BackColor = Color.Teal
            Me.AjoutDeFluxToolStripMenuItem.BackColor = Color.LightSeaGreen
            Me.ParamétresToolStripMenuItem1.BackColor = Color.LightSeaGreen
            Me.AProposToolStripMenuItem.BackColor = Color.LightSeaGreen
            Me.AideToolStripMenuItem.BackColor = Color.LightSeaGreen
            Me.QuitterToolStripMenuItem.BackColor = Color.LightSeaGreen
            FLux_Form.BackColor = Color.Teal
            FLux_Form.TextBox1.BackColor = Color.Teal
            Flux_Windows.BackColor = Color.Teal
            Flux_Windows.lstItems.BackColor = Color.Teal
            Flux_Windows.MenuStrip1.BackColor = Color.Teal
            Flux_Windows.AjoutRSSToolStripMenuItem.BackColor = Color.LightSeaGreen
            Flux_Windows.ActualiserToolStripMenuItem.BackColor = Color.LightSeaGreen
            Flux_Windows.IconesToolStripMenuItem.BackColor = Color.LightSeaGreen
            Flux_Windows.PictureBox3.BackColor = Color.Teal
            Flux_Ajout.BackColor = Color.Teal
            Flux_Ajout.Label1.BackColor = Color.Teal
            Flux_Ajout.Label2.BackColor = Color.Teal
            Flux_Ajout.new_flux_ajout.BackColor = Color.Teal
        End If
        If data_principal(1) = "6" Then 'Couleur bleu foncé
            Me.BackColor = Color.Navy
            Me.MenuStrip1.BackColor = Color.Navy
            Me.PictureBox1.BackColor = Color.Navy
            Me.PictureBox2.BackColor = Color.Navy
            Me.MenuStrip1.BackColor = Color.Navy
            Me.PictureBox1.BackColor = Color.Navy
            Me.PictureBox2.BackColor = Color.Navy
            Me.AjoutDeFluxToolStripMenuItem.BackColor = Color.RoyalBlue
            Me.ParamétresToolStripMenuItem1.BackColor = Color.RoyalBlue
            Me.AProposToolStripMenuItem.BackColor = Color.RoyalBlue
            Me.AideToolStripMenuItem.BackColor = Color.RoyalBlue
            Me.QuitterToolStripMenuItem.BackColor = Color.RoyalBlue
            FLux_Form.BackColor = Color.Navy
            FLux_Form.TextBox1.BackColor = Color.Navy
            Flux_Windows.BackColor = Color.Navy
            Flux_Windows.lstItems.BackColor = Color.Navy
            Flux_Windows.MenuStrip1.BackColor = Color.Navy
            Flux_Windows.AjoutRSSToolStripMenuItem.BackColor = Color.RoyalBlue
            Flux_Windows.ActualiserToolStripMenuItem.BackColor = Color.RoyalBlue
            Flux_Windows.IconesToolStripMenuItem.BackColor = Color.RoyalBlue
            Flux_Windows.PictureBox3.BackColor = Color.Navy
            Flux_Ajout.BackColor = Color.Navy
            Flux_Ajout.Label1.BackColor = Color.Navy
            Flux_Ajout.Label2.BackColor = Color.Navy
            Flux_Ajout.new_flux_ajout.BackColor = Color.Navy
        End If
        If data_principal(1) = "7" Then 'Couleur violet
            Me.BackColor = Color.Indigo
            Me.MenuStrip1.BackColor = Color.Indigo
            Me.PictureBox1.BackColor = Color.Indigo
            Me.PictureBox2.BackColor = Color.Indigo
            Me.AjoutDeFluxToolStripMenuItem.BackColor = Color.MediumPurple
            Me.ParamétresToolStripMenuItem1.BackColor = Color.MediumPurple
            Me.AProposToolStripMenuItem.BackColor = Color.MediumPurple
            Me.AideToolStripMenuItem.BackColor = Color.MediumPurple
            Me.QuitterToolStripMenuItem.BackColor = Color.MediumPurple
            FLux_Form.BackColor = Color.Indigo
            FLux_Form.TextBox1.BackColor = Color.Indigo
            Flux_Windows.BackColor = Color.Indigo
            Flux_Windows.lstItems.BackColor = Color.Indigo
            Flux_Windows.MenuStrip1.BackColor = Color.Indigo
            Flux_Windows.AjoutRSSToolStripMenuItem.BackColor = Color.MediumPurple
            Flux_Windows.ActualiserToolStripMenuItem.BackColor = Color.MediumPurple
            Flux_Windows.IconesToolStripMenuItem.BackColor = Color.MediumPurple
            Flux_Windows.PictureBox3.BackColor = Color.Indigo
            Flux_Ajout.BackColor = Color.Indigo
            Flux_Ajout.Label1.BackColor = Color.Indigo
            Flux_Ajout.Label2.BackColor = Color.Indigo
            Flux_Ajout.new_flux_ajout.BackColor = Color.Indigo
        End If
        If data_principal(1) = "8" Then 'Couleur violet foncé
            Me.BackColor = Color.Purple
            Me.MenuStrip1.BackColor = Color.Purple
            Me.PictureBox1.BackColor = Color.Purple
            Me.PictureBox2.BackColor = Color.Purple
            Me.AjoutDeFluxToolStripMenuItem.BackColor = Color.Violet
            Me.ParamétresToolStripMenuItem1.BackColor = Color.Violet
            Me.AProposToolStripMenuItem.BackColor = Color.Violet
            Me.AideToolStripMenuItem.BackColor = Color.Violet
            Me.QuitterToolStripMenuItem.BackColor = Color.Violet
            FLux_Form.BackColor = Color.Purple
            FLux_Form.TextBox1.BackColor = Color.Purple
            Flux_Windows.BackColor = Color.Purple
            Flux_Windows.lstItems.BackColor = Color.Purple
            Flux_Windows.MenuStrip1.BackColor = Color.Purple
            Flux_Windows.AjoutRSSToolStripMenuItem.BackColor = Color.Violet
            Flux_Windows.ActualiserToolStripMenuItem.BackColor = Color.Violet
            Flux_Windows.IconesToolStripMenuItem.BackColor = Color.Violet
            Flux_Windows.PictureBox3.BackColor = Color.Purple
            Flux_Ajout.BackColor = Color.Purple
            Flux_Ajout.Label1.BackColor = Color.Purple
            Flux_Ajout.Label2.BackColor = Color.Purple
            Flux_Ajout.new_flux_ajout.BackColor = Color.Purple
        End If
    End Sub

    Private Sub ParamétresToolStripMenuItem1_Click(sender As Object, e As EventArgs)
        Parametres.Show()
    End Sub

    Private Sub QuitterToolStripMenuItem1_Click_1(sender As Object, e As EventArgs) Handles QuitterToolStripMenuItem1.Click
        Application.Exit()
    End Sub

    Private Sub AjoutToolStripMenuItem1_Click_1(sender As Object, e As EventArgs) Handles AjoutToolStripMenuItem1.Click
        Flux_Ajout.Show()
    End Sub

    Private Sub ParamétresToolStripMenuItem1_Click_1(sender As Object, e As EventArgs) Handles ParamétresToolStripMenuItem1.Click
        Parametres.Show()
    End Sub

    Private Sub AjoutDeFluxToolStripMenuItem_Click_1(sender As Object, e As EventArgs) Handles AjoutDeFluxToolStripMenuItem.Click
        Flux_Ajout.Show()
    End Sub
    '============================================ TOOLTIPS Info ========================================================
    Private Sub PictureBox1MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles PictureBox1.MouseMove
        ToolTip1.SetToolTip(Me.PictureBox1, "Déplacer")
    End Sub
    Private Sub PictureBox1eLeave(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PictureBox1.MouseLeave

    End Sub

    Private Sub PictureBox3_Click(sender As Object, e As EventArgs) Handles PictureBox3.Click

    End Sub
    '-------------------------------------- CURSEURS -------------------------------------------------------------------------
    'Private Sub Menustrip1MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles MenuStrip1.MouseMove
    'Dim memory_stream As New System.IO.MemoryStream(My.Resources.Cur_Deplace)
    'PictureBox1.Cursor = New Cursor(memory_stream)
    'End Sub
End Class